/***************************************************************************

	ticker.c

    Get current ticks

***************************************************************************/

#include "psp.h"


/***************************************************************************
	Global variables
 ***************************************************************************/

TICKER TICKS_PER_SEC = 1000000;

static TICKER overflow_count = 0;
static u32 prev_count = 0;


/*--------------------------------------------------------
	Get current ticks
 -------------------------------------------------------*/

TICKER ticker(void)
{
	u32 current_count = sceKernelLibcClock();

	if (current_count < prev_count)
		overflow_count += ((TICKER)(1) << 32);

	prev_count = current_count;

	return (TICKER)current_count + overflow_count;
}
