/***************************************************************************

	sndintrf.c

	NEOGEO CD sound interface

***************************************************************************/

#include "ncdz.h"


/***************************************************************************
	Global variables
 **************************************************************************/

int	neogeo_sound_enable;
int	neogeo_samplerate;
int neogeo_sound_volume;


/*------------------------------------------------------
	Initialize sound emulation
 -----------------------------------------------------*/

int neogeo_sound_init(void)
{
	if (sound_thread_start())
	{
		sound_set_callback(YM2610Update);
	    YM2610_sh_start();
		return 1;
	}
	return 0;
}


/*------------------------------------------------------
	Shutdown sound emulation
 -----------------------------------------------------*/

void neogeo_sound_exit(void)
{
    YM2610_sh_stop();
	sound_thread_stop();
}


/*------------------------------------------------------
	Reset sound emulation
 -----------------------------------------------------*/

void neogeo_sound_reset(void)
{
	YM2610_sh_reset();
	neogeo_sound_mute(0);
}


/*------------------------------------------------------
	Mute sound
 -----------------------------------------------------*/

void neogeo_sound_mute(int mute)
{
	if (mute)
		sound_enable(0);
	else
		sound_enable(neogeo_sound_enable);
}
